// Lista wariantów. Klucze to teksty na stronie (a także wyświetlane
// przez nas), wartości to kodowe oznaczniki (np. używane w preferencjach)

var smtuning = {

    ////////////////////////////////////////////////////////////////////////////////
    // Realizacja poszczególnych elementów
    ////////////////////////////////////////////////////////////////////////////////

    displayToolbar : function(doc) {
        var prefString = smtext.prefman.getValue("toolbar",
             "/currentgames.aspx" + ".ITEM." + 'Game List'
             + ".NEXT."
             + "%PREVGAME%" + ".ITEM." + 'Prev Game'
             + ".NEXT."
             + "/forums.aspx" + ".ITEM." + 'Forum');
        var prevurl = smtext.prefman.getValue('data.PREVGAME', '');
        var toolbarData = prefString.split(".NEXT.");
        var toolbar = doc.createElement('div');
        toolbar.id = 'SmToolbar';
        var count = 0;
        for (var i=0; i < toolbarData.length; i++) {
            var pieces = toolbarData[i].split(".ITEM.");

            if (pieces[0] && pieces[1]) {
                var newItem = doc.createElement("a");
                newItem.setAttribute("href",
                                     pieces[0].replace(/%PREV(GAME|IOUS)%/, prevurl));
                newItem.setAttribute("class", "solidcell"); // Kolor tła wdg theme
                var linkText=doc.createTextNode(pieces[1]);
                newItem.appendChild(linkText);

                toolbar.appendChild(newItem);
                ++ count;
            }
        }
        if (! count) {
            toolbar.innerHTML = "No links defined.";
        }

        var title = smtdoc.xpathFirst(doc, "//h1");
        if (! title) return;
        //toolbar.innerHTML = toolbarLinks;
        //title.parentNode.insertBefore(toolbar, title.nextSibling);
        title.parentNode.insertBefore(toolbar, title);
    },

    addSortDropDown : function(doc, view) {
        var title = smtdoc.xpathFirst(doc, "//h1");
        if (! title) return;
        var dropdown = doc.createElement("select");
        dropdown.setAttribute("id", "SmGameSortSelect");
        dropdown.setAttribute("onChange", "smtdoc.resortGames(this.options[selectedIndex].value)");
        //dropdown.setAttribute("style", "float: right");
        title.parentNode.insertBefore(dropdown, title);
        dropdown.options[dropdown.options.length] = new Option("-- Change ordering --", "0");
        dropdown.options[dropdown.options.length] = new Option("Default", "9");
        dropdown.options[dropdown.options.length] = new Option("By variant", "1");
        dropdown.options[dropdown.options.length] = new Option("By variant (rev)", "2");
        dropdown.options[dropdown.options.length] = new Option("By start date (up)", "5");
        dropdown.options[dropdown.options.length] = new Option("By start date (down)", "6");
        dropdown.options[dropdown.options.length] = new Option("By opponent name", "11");
        dropdown.options[dropdown.options.length] = new Option("By opponent clock", "13");
    },

    addDarkPreviewDropDown : function(doc, view) {
        var title = smtdoc.xpathFirst(doc, "//h1");
        if (! title) return;
        var dropdown = doc.createElement("select");
        dropdown.setAttribute("id", "SmGameSortSelect");
        dropdown.setAttribute("onChange", "smtdoc.redisplayDark(this.options[selectedIndex].value)");
        //dropdown.setAttribute("style", "float: right");
        title.parentNode.insertBefore(dropdown, title);
        dropdown.options[dropdown.options.length] = new Option("-- Change point of view --", "");
        dropdown.options[dropdown.options.length] = new Option("See everything", "all");
        dropdown.options[dropdown.options.length] = new Option("White view", "white");
        dropdown.options[dropdown.options.length] = new Option("Black view", "black");
    },

    scrollDownMovesPane: function(doc) {
        var objDiv = doc.getElementById('Div1');
        objDiv.scrollTop = objDiv.scrollHeight;
    },

    scrollDownWholeWindow : function(view, makeToolbar) {
        // window.scroll(0, window.innerHeight);
        if( makeToolbar ) {
            view.scroll(120, 60);
        } else {
            view.scroll(120, 80);
        }
    },

    // Ustala jaki wariant jest wyświetlony
    detectVariant: function(doc) {
        var objDiv = doc.getElementById('Div1');
        var spanArray = objDiv.getElementsByTagName('span');
        var variant = spanArray[0].innerHTML;
        var variant_code = smtvariants.variantInternalByPublic(variant);
        return variant_code || 'chess';
    },


    // Wymiana obrazków - akcja po załadowaniu
    replacePieces: function(doc, view, wantedSetName, pieceSize) {
        if (! wantedSetName || ! pieceSize) return;

        var setObj = smtpieces.pieceByName(wantedSetName);
        var newUrl = setObj.piecesPath(pieceSize);
        var oldPathFrag = 'images/sets';
        // oldPathFrag = '/pieces/';

        smtdoc.replacePieces(doc, view, newUrl, pieceSize, oldPathFrag, setObj.fileExt());
    },


    correctSizing : function(doc, view, pieceSize) {
        smtdoc.correctBoardPageSizing(doc, 32, pieceSize);
    },

    // Interpretuje planszę i zgaduje jaki zegar jest używany.
    handleClockColorizingOnBoard : function(doc, view, gameId) {
        var clockPref = 'data.clock.' + gameId;
        var clockType = smtext.prefman.getValue(clockPref);
        if (! clockType) { // Jeśli znamy, nie trzeba szukać na nowo
            var clkDesc = smtdoc.xpathFirst(doc, "//table[@id='ctl00_ContentPlaceHolder1_Table8']//table//td[contains(.,'days +')]/text()");
            var clkRe = /([0-9]+)\s*days\s*\+\s*([0-9]+)/;
            if (clkDesc.data.match(clkRe)) {
                if (RegExp.$1 == "5") {
                    clockType = "blitz";
                }
                else if (RegExp.$1 == "10") {
                    clockType = "fast";
                }
                else if (RegExp.$1 == "30") {
                    if (RegExp.$2 == "1" ) {
                        clockType = "standard";
                    } else if (RegExp.$2 == "3") {
                        clockType = "leisure";
                    }
                }
                if (clockType) {
                    smtext.prefman.setValue(clockPref, clockType);
                }
            }
        }

        //smtext.dump("Clock type: " + clockType);

        // A teraz patchujemy
        if (clockType) {
            smtuning.replaceClockIcons(doc, null, clockType);
        }
    },

    // Funkcja pomocnicza. W podanym bloku wyszukuje wszystkie ikony
    // zegarka i podmienia na zadane. block należy podać tylko gdy nie jest null
    replaceClockIcons : function(doc, block, clockType) {
        var pfx = "";
        if( block ) {
            pfx = "td";
        } else {
            block = doc;
        }
        var nodes = smtdoc.xpathRelative(
            doc, block,
            pfx + "//img[contains(@src,'/clock.gif')]");
        for (var i = 0; i < nodes.snapshotLength; i++) {
            var thisImg = nodes.snapshotItem(i);
            //smtext.dump("Patching " + thisImg.getAttribute("src") + " to " + clockType);
            thisImg.setAttribute("src","chrome://smtuning/skin/clock/clock_" + clockType + ".gif");
        }
        var nodes = smtdoc.xpathRelative(
            doc, block,
            pfx + "//img[contains(@src,'/clocka.gif')]");
        for (var i = 0; i < nodes.snapshotLength; i++) {
            var thisImg = nodes.snapshotItem(i);
            //smtext.dump("Patching " + thisImg.getAttribute("src") + " to " + clockType);
            thisImg.setAttribute("src","chrome://smtuning/skin/clock/clocka_" + clockType + ".gif");
        }
    },

    // Modyfikacje listy partii
    patchGameList : function(doc, view, colorizeClock) {
        var rows = smtdoc.xpath(doc,
                                "//table[@id='ctl00_ContentPlaceHolder1_Table1']//tr[contains(@onclick,'window.location.href')]");
        for (var i = 0; i < rows.snapshotLength; i++) {
            var row = rows.snapshotItem(i);
            var link = row.getAttribute("onclick");
            if (link.match(/game_id=([0-9]+)/)) {
                var gameId = RegExp.$1;
                if (colorizeClock) {
                    var clockType = smtext.prefman.getValue('data.clock.' + gameId, '');
                    if (clockType) {
                        //smtext.dump("row " + i + " clock " + clockType);
                        smtuning.replaceClockIcons(doc, row, clockType);
                    }
                }
            }
        }
    },

    enableSaveFlipAnalysis : function(doc, view, saveAnalysis, flipAnalysis) {
        var buttonsRow = smtdoc.xpathFirst(doc,
                      "//table[@id='ctl00_ContentPlaceHolder1_Table1']//tr");
        if (buttonsRow) {
            if (flipAnalysis) {
                var flip = doc.createElement("img");
                flip.setAttribute("src", "chrome://smtuning/skin/flip.png");
                flip.setAttribute("title", "Flip analysis board");
                flip.setAttribute("onClick", "smtdoc.analysisFlip()");
                flip.id = 'SmAnalysisFlip';
                var flipTd = doc.createElement("td");
                flipTd.setAttribute("style", "padding-left: 6px");
                flipTd.appendChild(flip);
                buttonsRow.appendChild(flipTd);
            }
            if (saveAnalysis) {
                var save = doc.createElement("img");
                save.setAttribute("src", "chrome://smtuning/skin/analysis_save.png");
                save.setAttribute("title", "Copy analysis board to private note");
                save.setAttribute("onClick", "smtdoc.analysisSave()");
                save.id = 'SmAnalysisSave';
                var saveTd = doc.createElement("td");
                saveTd.setAttribute("style", "padding-left: 6px");
                saveTd.appendChild(save);
                buttonsRow.appendChild(saveTd);
            }
        }

        // Podmiana fenów na linki
        if (saveAnalysis) {
            var nodes = smtdoc.xpathAsArray(doc, "//div[@id='Div4']//span[contains(@style,'Maroon')]//text()");
            nodes = nodes.concat(
                smtdoc.xpathAsArray(doc, "//div[@id='Div1']//span[contains(@style,'Maroon')]//span//text()"));
            var fenRe = /([KQRNBPkqrnbp1-8]{1,8}\/[KQRNBPkqrnbp1-8]{1,8}\/[KQRNBPkqrnbp1-8]{1,8}\/[KQRNBPkqrnbp1-8]{1,8}\/[KQRNBPkqrnbp1-8]{1,8}\/[KQRNBPkqrnbp1-8]{1,8}\/[KQRNBPkqrnbp1-8]{1,8}\/[KQRNBPkqrnbp1-8]{1,8})/;
            while (nodes.length > 0) {
                var node = nodes.shift();
                // też działa: smtext.dump("TC: " + note.textContent);
                // smtext.dump("DATA: " + node.data);
                // Algorytm: szukamy pierwszego wystąpienia FEN.
                // Splitujemy tekst przed nim (jeśli jest), zamieniamy na link
                // sam FEN a to co po nim splitujemy i dodajemy do rzeczy do
                // sprawdzenia
                var fenMatch = node.data.match(fenRe);
                if (! fenMatch) continue;
                if (RegExp.leftContext) {
                    node.splitText(RegExp.leftContext.length);
                    // lenistwo, by nie przeliczać położeń
                    //node = node.nextSibling;
                    nodes.unshift(node.nextSibling);
                    continue;
                }
                if (RegExp.rightContext) {
                    node.splitText(RegExp.lastMatch.length);
                    nodes.push(node.nextSibling);
                }
                var link = doc.createElement("a");
                link.href = "javascript:smtdoc.analysisLoad('"+RegExp.lastMatch+"')";
                link.setAttribute("title", "Display on analysis board: " + RegExp.lastMatch);
                node.parentNode.insertBefore(link, node);
                node.data = node.data.substr(0,12) + "...";
                link.appendChild(node);
            }
        }
    },

    shortenCommentLabels : function(doc, view) {
        var nodes = smtdoc.xpathAsArray(doc, "//div[@id='Div4']//span//text()");
        nodes = nodes.concat(
            smtdoc.xpathAsArray(doc, "//div[@id='Div1']//span//text()"));
        //smtext.dump("FOUND: " + nodes.length);
        var txtRe = /(Private game note:)/;
        while (nodes.length > 0) {
            var node = nodes.shift();
            //smtext.dump(node.data);
            if(node.data.match(txtRe)) {
                smtext.dump("replacing");
                node.replaceData(RegExp.leftContext.length,
                                 RegExp.lastMatch.length,
                                 "Private:");
            }
            // też działa: smtext.dump("TC: " + note.textContent);
            //smtext.dump("DATA: " + node.data);
            //node.data = node.data.replace(txtRe, "Private:");
            //smtext.dump("AFTER: " + node.data);
        }
    },

    enableZoom : function(doc, view, wantedSetName) {
        var board = smtdoc.xpathFirst(doc, "//div[starts-with(@class,'board')]");
        if (! board) {
            return;
        }

        smtdoc.addJavaScript(doc, "smtPieceSet = smtpieces.pieceByName('"
                             + wantedSetName + "')");

        var zoomIn = doc.createElement("img");
        zoomIn.setAttribute("src", "chrome://smtuning/skin/zoomin.png");
        zoomIn.setAttribute("title", "Zoom In (make pieces greater)");
        zoomIn.setAttribute("onClick", "smtdoc.zoomIn()");
        zoomIn.id = 'SmZoomIn';
        var zoomOut = doc.createElement("img");
        zoomOut.setAttribute("src", "chrome://smtuning/skin/zoomout.png");
        zoomOut.setAttribute("title", "Zoom Out (make pieces smaller)");
        zoomOut.setAttribute("onClick", "smtdoc.zoomOut()");
        zoomOut.id = 'SmZoomOut';
//         zoomOut.addEventListener("click", function(e) {
//                 alert("zoom Out");
//                 var img = e.target;
//                 var doc = img.ownerDocument;
//                 // if (img.wrappedJSObject) img=img.wrappedJSObject;
//                 // var view = img.ownerDocument;
//                 smtdoc.replacePieces(doc, window,
//                                      "chrome://smtuning/content/pieces/igor_k/40",
//                                      40,
//                                      'content/pieces');
//                 smtdoc.correctBoardPageSizing(doc, 48, 40);
//             }, false);
        board.appendChild(zoomIn);
        board.appendChild(zoomOut);
        //var zoomOut
    },

    correctBoardLayout : function(doc, view) {
        // rozmiar labelek
        var perc1 = smtdoc.xpathFirst(doc, "//td[contains(@width,'45%')]");
        if (perc1) {
            perc1.setAttribute('width', '55%');
        }
        var perc2 = smtdoc.xpathFirst(doc, "//td[contains(@width,'30%')]");
        if (perc2) {
            perc2.setAttribute('width', '25%');
        }

        // rowspan
        var tds = smtdoc.xpathOrdered(doc, "//td[contains(@class,'solidcell')]");
        if (tds.snapshotLength == 4) {
            var empty = tds.snapshotItem(0);
            //var tabs = tds.snapshotItem(1);
            var board = tds.snapshotItem(2);
            //var moves = tds.snapshotItem(3);
            board.setAttribute("rowspan", 2);
            empty.parentNode.insertBefore(board, empty);
            empty.parentNode.removeChild(empty);
        }
    },

    colorizeCommentBox : function(doc, view) {
        var radioList = smtdoc.xpath(doc, "//input[contains(@name,'ctl00$ContentPlaceHolder1$rblMoveOptions')]");
        function privateCommentClicked(e) {
            var cbox = e.view.document.getElementById('ctl00_ContentPlaceHolder1_txtComment');
            if (cbox) {
                cbox.setAttribute("style", "color: red");
            }
        }
        function otherCommentClicked(e) {
            var cbox = e.view.document.getElementById('ctl00_ContentPlaceHolder1_txtComment');
            if (cbox) {
                cbox.setAttribute("style", "color: black");
            }
        }
        for (var i = 0; i < radioList.snapshotLength; i++) {
            var thRadio = radioList.snapshotItem(i);
            // alert(thRadio.getAttribute("value"));
            if (thRadio.getAttribute("value") == "private_comment") {
                thRadio.addEventListener('click', privateCommentClicked, true);
            } else {
                thRadio.addEventListener('click', otherCommentClicked, true);
            }
        }
        // alert("Not (yet) - enable colorization of comment box");
    },

    signalEngineUse : function(doc, view) {
        //alert("Peeking for engine use...");
        var info = smtdoc.xpathFirst(doc, "//span[contains(.,'Chess engines allowed')]");
        if (! info) return;
        //alert("Yes, engine!");
        smtdoc.addStyleSheet(doc, "chrome://smtuning/skin/smtuning_engine.css");
    },

    addExtraMarkAsReadForum : function(doc, view) {
        var sample = smtdoc.xpathFirst(doc, "//a[contains(.,'Mark all posts')]");
        var start_new = smtdoc.xpathFirst(doc, "//a[contains(.,'Start a new topic')]");
        var topic = smtdoc.xpathFirst(doc, "//td[contains(.,'Topic')]");
        if (! (sample && topic)) return;
        var newMarkTd = sample.parentNode.cloneNode(true);

        var newTr = doc.createElement("tr");
        newTr.appendChild(newMarkTd);

        if( start_new ) {
            var newStartTd = start_new.parentNode.cloneNode(true);
            newMarkTd.setAttribute("colspan", 2);
            newStartTd.setAttribute("colspan", 2);
            newMarkTd.setAttribute("style", "border-right: none");
            newStartTd.setAttribute("style", "border-left: none; text-align: right");       
            newTr.appendChild(newStartTd);
        }

        var titleRow = topic.parentNode;
        titleRow.parentNode.insertBefore(newTr, titleRow.nextSibling);
    },

    addExtraMarkAsReadForumList : function(doc, view) {
        var sample = smtdoc.xpathFirst(doc, "//a[contains(.,'Mark all posts')]");
        var topic = smtdoc.xpathFirst(doc, "//td[contains(.,'Forum Name')]");
        if (! (sample && topic)) return;
        var newLinkRow = sample.parentNode.cloneNode(true);
        var titleRow = topic.parentNode;
        titleRow.parentNode.insertBefore(newLinkRow, titleRow.nextSibling);
    },

    addExtraMarkAsReadInbox : function(doc, view) {
        var sample = smtdoc.xpathFirst(doc, "//a[contains(.,'Mark all messages')]");
        var topic = smtdoc.xpathFirst(doc, "//td[contains(.,'Inbox')]");
        if (! (sample && topic)) return;
        var newLinkRow = sample.parentNode.cloneNode(true);
        var titleRow = topic.parentNode;
        titleRow.parentNode.insertBefore(newLinkRow, titleRow.nextSibling);
    },

    addExtraMarkAsReadCompleted : function(doc, view) {
        var sample = smtdoc.xpathFirst(doc, "//a[contains(.,'Mark completed games')]");
        var topic = smtdoc.xpathFirst(doc, "//td[contains(.,'Game')]");
        if (! (sample && topic)) return;
        var newLinkRow = sample.parentNode.cloneNode(true);
        var titleRow = topic.parentNode;
        titleRow.parentNode.insertBefore(newLinkRow, titleRow.nextSibling);
    },

    hideNonEnglish : function(doc, view) {
        var section = smtdoc.xpathFirst(doc, "//td[contains(.,'Non-English Language Forums')]/..");
        if (! section) return;
        var table = section.parentNode;
        table.removeChild(section.nextSibling);
        table.removeChild(section.nextSibling);
        table.removeChild(section.nextSibling);
        table.removeChild(section);
    },

    removeAvatars : function(doc, view) {
        var avatars = smtdoc.xpath(doc, "//img[@class='avatar']");
        for (var i = 0; i < avatars.snapshotLength; i++) {
            var av = avatars.snapshotItem(i);
            av.parentNode.removeChild(av);
        }
    },

    patchWindowBackground: function(doc, view) {
        var which = smtext.prefman.getValue("patch_window_background_to");

        var alice, css, menu, menu1;
        if( which == "black_and_white" ) {
            alice = "alt_black_and_white/alice.jpg";
            css_name = "alt_black_and_white/smtuning_document.css";
            menu = "alt_black_and_white/menu.gif";
            menu1 = "alt_black_and_white/menu1.gif";
            post = "alt_black_and_white/post.gif";
            post1 = "alt_black_and_white/post1.gif";
        }
        else {
            alice = "alt_dark/alice.png";
            css_name = "alt_dark/smtuning_document.css";
        }
        
        var body = smtdoc.xpathFirst(doc, "//body");
        /* if(body) {
            body.setAttribute("style", "background-color: #5c6f6f");
            } */
        var img = doc.getElementById("ctl00_alice");
        if(img) {
            img.setAttribute("src", "chrome://smtuning/skin/" + alice);
        }
        smtdoc.addStyleSheet(doc, "chrome://smtuning/skin/" + css_name);

        if(menu) {
            smtdoc.replaceImage(doc, 'menu.gif',
                                "chrome://smtuning/skin/" + menu);
        }
        if(menu1) {
            smtdoc.replaceImage(doc, 'menu1.gif', 
                                "chrome://smtuning/skin/" + menu1);
        }

        if(post) {
            smtdoc.replaceImage(doc, 'post.gif',
                                "chrome://smtuning/skin/" + post);
        }
        if(post1) {
            smtdoc.replaceImage(doc, 'post1.gif', 
                                "chrome://smtuning/skin/" + post1);
        }

    },

    patchWindowTitle : function(doc, view) {
        // smtext.dump("Window title: " + doc.title);
        if (doc.title.match(/SchemingMind\.com[ \-]*Internet *Correspondence *Chess/i)) {
            //var title = smtdoc.xpathFirst(doc, "//h1/text()");
            var title = smtdoc.xpathFirst(doc, "//h1");
            if (! title) return;
            //title = title.innerHTML;
            title = title.textContent;
            title = title.replace(/^[ \r\n]+/, "");
            title = title.replace(/[ \r\n]+$/, "");
            title = title.replace(/[ \r\n][ \r\n]+/g, " ");
            // smtext.dump("Doc title: " + title);
            //doc.title = "SM: " + title;
            doc.title = title;
        }
    },

    ////////////////////////////////////////////////////////////////////////////////
    // Funkcje pomocnicze (głównego poziomu)
    ////////////////////////////////////////////////////////////////////////////////

    onPageLoad : function(e) {
        // window.content.document.addEventListener("mouseover", this.handleMouseOverEvent, false);
        var href = e.originalTarget.location.href;
        //var doc = window.content.document;
        var doc = e.originalTarget;
        // e.view.document

        var view = e.target.defaultView; // unsafeWindow
        if (view.wrappedJSObject) view=view.wrappedJSObject;

        if (href.match( /^http:\/\/(www\.)?schemingmind\.com/)
            || href.match( /^file:\/\/.*\/schemingmind_monkey\/testpages\// ) ) {
            // Można by próbowac to wrzucać tylko dla wybranych opcji,
            // ale tak prościej.
            smtdoc.addStyleSheet(doc, "chrome://smtuning/skin/smtuning_document.css");            
            // Jak wyżej
            smtdoc.addJavaScriptFile(doc, "chrome://smtuning/content/smt_docutil.js");
            smtdoc.addJavaScriptFile(doc, "chrome://smtuning/content/smt_pieces.js");

            var makeToolbar = smtext.prefman.getValue("make_toolbar");
            var signalClock = smtext.prefman.getValue("signal_games_clock");
            var patchTitle = smtext.prefman.getValue("patch_window_title");
            var patchBackground = smtext.prefman.getValue("patch_window_background");

            if( makeToolbar ) {
                smtuning.displayToolbar(doc);
            }

            if (patchTitle) {
                smtuning.patchWindowTitle(doc, view);
            }

            if (patchBackground) {
                smtuning.patchWindowBackground(doc, view);
            }

            // Board page
            if (href.match(/schemingmind\.com\/(xfcc)?game\.aspx\?game_id=(\d+)/i)
                || href.match(/testpages\/[^\/]+\-game\.html/) ) {
                var gameId = RegExp.$2;
                //alert(gameId);
                if (makeToolbar) {
                    smtext.prefman.setValue('data.PREVGAME', href);
                }

                var scrollMoves = smtext.prefman.getValue("scroll_moves");
                var scrollPage = smtext.prefman.getValue("scroll_board_page");
                var pieceByVariant = smtext.prefman.getValue("piece_by_variant");
                var changeBoard = smtext.prefman.getValue("change_board_layout");
                var colorizeComments = smtext.prefman.getValue("colorize_comment_box");
                var signalEngineUse = smtext.prefman.getValue("signal_engine_use");
                var pieceSize = smtext.prefman.getValue("piece_size");
                var enableZoom = smtext.prefman.getValue("zoom");
                var saveAnalysis = smtext.prefman.getValue("save_analysis");
                var flipAnalysis = smtext.prefman.getValue("flip_analysis");
                var darkPreviewDropdown = smtext.prefman.getValue("dark_preview_dropdown");
                var shortenCommentLabels = smtext.prefman.getValue("shorten_comment_labels");
                // alert("Wanted size: " + pieceSize);

                var wantedSetName;
                var shouldReplace = (pieceSize != 32);
                var variant = smtuning.detectVariant(doc);
                if (pieceByVariant && variant) {
                    wantedSetName = smtext.prefman.getValue("set_" + variant);
                    shouldReplace = true;
                }
                else {
                    wantedSetName = smtext.prefman.getValue("set_chess");
                }
                if (! wantedSetName) {
                    wantedSetName = smtpieces.firstMatchingPiece(variant).name();
                }

                if (shouldReplace) {
                    smtuning.replacePieces(doc, view, wantedSetName, pieceSize);
                }

                if (pieceSize != 32) {
                    smtuning.correctSizing(doc, view, pieceSize);
                }
                if (changeBoard) {
                    smtuning.correctBoardLayout(doc, view);
                }
                if (colorizeComments) {
                    smtuning.colorizeCommentBox(doc, view);
                }
                if (signalEngineUse) {
                    smtuning.signalEngineUse(doc, view);
                }
                if (enableZoom) {
                    smtuning.enableZoom(doc, view, wantedSetName);
                }

                if (scrollMoves) {
                    smtuning.scrollDownMovesPane(doc);
                }
                if (scrollPage) {
                    smtuning.scrollDownWholeWindow(view, makeToolbar);
                }
                if (saveAnalysis || flipAnalysis) {
                    smtuning.enableSaveFlipAnalysis(
                        doc, view,
                        saveAnalysis, flipAnalysis);
                }
                if (signalClock && gameId) {
                    smtuning.handleClockColorizingOnBoard(doc, view, gameId);
                }
                if (darkPreviewDropdown) {
                    if (smtvariants.isDark(variant)) {
                        // Sprawdzanie czy partia jest skończona.
                        // Zdecydowałem się szukać ... obrazka clocks.gif,
                        // który łatwiej szukać niż napisów
                        var game_finished = smtdoc.xpathFirst(
                            doc, "//img[contains(@src,'clocks.gif')]");
                        if (game_finished) {
                            smtuning.addDarkPreviewDropDown(doc, view);
                        }
                    }
                }
                if (shortenCommentLabels) {
                    smtuning.shortenCommentLabels(doc, view);
                }
            }

            // Current Games
            if (href.match(/schemingmind\.com\/currentgames.aspx/i)
                || href.match(/testpages\/currentgames\.html/) ) {
                var drop = smtext.prefman.getValue("sort_games_drop");
                if (drop) {
                    smtuning.addSortDropDown(doc, view);
                }
                if (signalClock) {
                    smtuning.patchGameList(doc, view, signalClock);
                }
            }

            // Completed Games
            if (href.match(/schemingmind\.com\/completedgames.aspx/i)
                || href.match(/testpages\/completedgames\.html/) ) {
                var extraMark = smtext.prefman.getValue("extra_mark_read");
                if (extraMark) {
                    smtuning.addExtraMarkAsReadCompleted(doc, view);
                }
            }

            // Inbox
            if (href.match(/schemingmind\.com\/pminbox.aspx/i)
                || href.match(/testpages\/pminbox\.html/) ) {
                var extraMark = smtext.prefman.getValue("extra_mark_read");
                if (extraMark) {
                    smtuning.addExtraMarkAsReadInbox(doc, view);
                }
            }

            // Forum topics
            if (href.match(/schemingmind\.com\/topics.aspx/i)
                || href.match(/testpages\/topics\.html/) ) {
                var extraMark = smtext.prefman.getValue("extra_mark_read");
                if (extraMark) {
                    smtuning.addExtraMarkAsReadForum(doc, view);
                }
            }

            // Forum list
            if (href.match(/schemingmind\.com\/forums.aspx/i)
                || href.match(/testpages\/forums\.html/) ) {
                var hideNonEng = smtext.prefman.getValue("hide_non_english");
                if (hideNonEng) {
                    smtuning.hideNonEnglish(doc, view);
                }
                var extraMark = smtext.prefman.getValue("extra_mark_read");
                if (extraMark) {
                    smtuning.addExtraMarkAsReadForumList(doc, view);
                }
            }

            // Forum topic text
            if (href.match(/schemingmind\.com\/topic.aspx/i)
                || href.match(/testpages\/topic\.html/) ) {
                var noAvatars = smtext.prefman.getValue("no_avatars");
                if (noAvatars) {
                    smtuning.removeAvatars(doc, view);
                }
            }

        }
    },

    // Called when new browser window is open
    onWindowOpen: function() {
        // Efekt generatora, do zrozumienia
        //this.initialized = true;
        //this.strings = document.getElementById("smtuning-strings");
        //document.getElementById("contentAreaContextMenu")
        //          .addEventListener("popupshowing", function(e) { this.showContextMenu(e); }, false);
        //alert("smtuning onLoad");

        // http://developer.mozilla.org/en/docs/Code_snippets:On_page_load
        var appcontent = window.document.getElementById("appcontent");
        if (appcontent) {
            if (!appcontent.smtuningactive) {
                appcontent.smtuningactive = true;
                appcontent.addEventListener("DOMContentLoaded", smtuning.onPageLoad, false);
                // appcontent.addEventListener("click", cg_handle_click, false);
            }
        }

        // http://kb.mozillazine.org/Adding_items_to_menus
        var menu = document.getElementById("contentAreaContextMenu");
        menu.addEventListener("popupshowing", smtuning.onPopupShowing, false);

        // Eksperymenty z progressem
        // top.getBrowser().addProgressListener(gProgressListener,
        //    Components.interfaces.nsIWebProgress.NOTIFY_STATE_WINDOW);
    },

    onWindowClosed : function(e) {
        // top.getBrowser().removeProgressListener(gProgressListener);
    },

    onPopupShowing : function(e) {
        // show or hide the menuitem based on what the context menu is on
        // see http://kb.mozillazine.org/Adding_items_to_mensu

        var menuitem = document.getElementById("context-smtuning");
        if(menuitem) {
            var href = window.content.location.href;
            if (href.match( /http:\/\/(www\.)?schemingmind\.com/)
                || href.match( /schemingmind_monkey\/testpages/) ) {
                menuitem.hidden = false;
            } else {
                menuitem.hidden = true;
            }
        }
    },

    onMenuItemCommand: function(e) {
        //var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
        //.getService(Components.interfaces.nsIPromptService);
        //promptService.alert(window, this.strings.getString("helloMessageTitle"),
        //                    this.strings.getString("helloMessage"));
        smtext.openPrefs();
    }
};

//window.addEventListener("load", function(e) { smtuning.onWindowOpen(e); }, false);
window.addEventListener("DOMContentLoaded", function(e) { smtuning.onWindowOpen(e); }, false);
window.addEventListener("unload", function(e) { smtuning.onWindowClosed(e); }, false);